/*
    CozyCL, a comfortable OpenCL library
    Copyright (C) 2013  Tamas Bolner
	For more information, visit: http://blog.bolner.hu/2013/02/19/cozycl
	
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#define FE_MESSAGE_BUFFER_SIZE 4096

/**
 * Exception class with printf like text formatting
 * capabilities, using variable argument list.
 */
class FException {
private:
	char error_msg[FE_MESSAGE_BUFFER_SIZE];
	unsigned __int64 error_code;

protected:

public:
	FException(char* error_msg, ...);
	FException(unsigned __int64 error_code, char* error_msg, ...);

	void Print();
	unsigned __int64 getErrorCode();
	char *getMessage();
};
